unit fOptionsOther;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, ORCtrls, ORFn;

type
  TfrmOptionsOther = class(TForm)
    pnlBottom: TPanel;
    btnOK: TButton;
    btnCancel: TButton;
    chkLastTab: TCheckBox;
    lblTab: TLabel;
    bvlBottom: TBevel;
    cboTab: TORComboBox;
    bvlNote: TBevel;
    lblImaging: TLabel;
    bvlTab: TBevel;
    lblTabDefault: TLabel;
    lblImagingMax: TLabel;
    txtImagingMax: TEdit;
    spnImagingMax: TUpDown;
    lblImagingStop: TLabel;
    lblImagingStart: TLabel;
    lblImagingDesc: TLabel;
    txtImagingStart: TEdit;
    spnImagingStart: TUpDown;
    txtImagingStop: TEdit;
    spnImagingStop: TUpDown;
    btnImagingDefaults: TButton;
    procedure FormShow(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure txtImagingMaxChange(Sender: TObject);
    procedure txtImagingMaxExit(Sender: TObject);
    procedure txtImagingMaxKeyPress(Sender: TObject; var Key: Char);
    procedure spnImagingMaxClick(Sender: TObject; Button: TUDBtnType);
    procedure btnImagingDefaultsClick(Sender: TObject);
    procedure txtImagingStartExit(Sender: TObject);
    procedure txtImagingStartKeyPress(Sender: TObject; var Key: Char);
    procedure txtImagingStartKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure spnImagingStartClick(Sender: TObject; Button: TUDBtnType);
    procedure txtImagingStopExit(Sender: TObject);
    procedure txtImagingStopKeyPress(Sender: TObject; var Key: Char);
    procedure txtImagingStopKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure spnImagingStopClick(Sender: TObject; Button: TUDBtnType);
  private
    { Private declarations }
    FStartEntered: boolean;
    FStopEntered: boolean;
//    procedure AdjustImagingLabel;
  public
    { Public declarations }
  end;

var
  frmOptionsOther: TfrmOptionsOther;

procedure DialogOptionsOther(topvalue, leftvalue, fontsize: integer; var actiontype: Integer);

implementation

{$R *.DFM}

uses
  rOptions, uOptions, rCore, rSurgery, uConst; //, rTIU, rDCSumm;

procedure DialogOptionsOther(topvalue, leftvalue, fontsize: integer; var actiontype: Integer);
// create the form and make it modal, return an action
var
  frmOptionsOther: TfrmOptionsOther;
begin
  frmOptionsOther := TfrmOptionsOther.Create(Application);
  actiontype := 0;
  try
    with frmOptionsOther do
    begin
      if (topvalue < 0) or (leftvalue < 0) then
        Position := poScreenCenter
      else
      begin
        Position := poDesigned;
        Top := topvalue;
        Left := leftvalue;
      end;
      if fontsize = 8 then Font.Size := 8
      else Font.Size := 10;
      ShowModal;
      actiontype := btnOK.Tag;
    end;
  finally
    frmOptionsOther.Release;
  end;
end;

procedure TfrmOptionsOther.FormShow(Sender: TObject);
// displays defaults
// opening tab^use last tab^autosave seconds^verify note title
var
  last: integer;
  values, tab: string;
begin
  cboTab.Items.Assign(rpcGetOtherTabs);
  if (cboTab.Items.IndexOf('Surgery') > -1) and (not ShowSurgeryTab) then
    cboTab.Items.Delete(cboTab.Items.IndexOf('Surgery'));
  values := rpcGetOther;
  tab := Piece(values, '^', 1);
  last := strtointdef(Piece(values, '^', 2), 0);
  cboTab.SelectByID(tab);
  cboTab.Tag := strtointdef(tab, -1);
  chkLastTab.Checked := last = 1;
  chkLastTab.Tag := last;
  cboTab.SetFocus;

{  rpcGetImagingDays(imagemaxdef, imagestartdef, imagestopdef);
  rpcGetImagingUserDays(imagemax, imagestart, imagestop);
  txtImagingMax.Text := inttostr(imagemax);
  txtImagingMax.Tag := imagemax;
  txtImagingStart.Tag := imagestart - 1;
  txtImagingStop.Tag := imagestop - 1;
  spnImagingMax.Tag := imagemaxdef;
  spnImagingStart.Tag := imagestartdef;
  spnImagingStop.Tag := imagestopdef;
  spnImagingMaxClick(self, btNext);
  spnImagingStartClick(self, btNext);
  spnImagingStopClick(self, btNext);
}
end;

procedure TfrmOptionsOther.btnOKClick(Sender: TObject);
// only saves values if they have been changed
// opening tab^use last tab^autosave seconds^verify note title
var
  values: string;
begin
  values := '';
  //if cboTab.ItemID <> cboTab.Tag then     {RV - v16.3)
  if cboTab.ItemIEN <> cboTab.Tag then
    values := values + cboTab.ItemID;
  values := values + '^';
  if chkLastTab.Checked then
    if chkLastTab.Tag <> 1 then
      values := values + '1';
  if not chkLastTab.Checked then
    if chkLastTab.Tag <> 0 then
      values := values + '0';
  values := values + '^^';
  rpcSetOther(values);

//  rpcSetImagingDays(spnImagingMax.Position, txtImagingStart.Tag, txtImagingStop.Tag);
end;

procedure TfrmOptionsOther.FormCreate(Sender: TObject);
begin
  FStartEntered := false;
  FStopEntered := false;
end;

procedure TfrmOptionsOther.txtImagingMaxChange(Sender: TObject);
begin
{  maxvalue := spnImagingMax.Max;
  with txtImagingMax do
  begin
    if strtointdef(Text, maxvalue) > maxvalue then
    begin
      beep;
      MessageDlg('Number must be < ' + inttostr(maxvalue), mtWarning, [mbOK], 0);
      if strtointdef(Text, 0) > maxvalue then
        Text := inttostr(maxvalue);
    end;
  end;
  spnImagingMaxClick(self, btNext);
}
end;

procedure TfrmOptionsOther.txtImagingMaxExit(Sender: TObject);
begin
{  with txtImagingMax do
  begin
    if Text = '' then
    begin
      Text := '0';
      spnImagingMaxClick(self, btNext);
    end
    else if (Copy(Text, 1, 1) = '0') and (length(Text) > 1) then
    begin
      Text := inttostr(strtointdef(Text, 0));
      spnImagingMaxClick(self, btNext);
    end;
  end;
 }
end;

procedure TfrmOptionsOther.txtImagingMaxKeyPress(Sender: TObject;
  var Key: Char);
begin
{  if Key = #13 then
  begin
    Perform(WM_NextDlgCtl, 0, 0);
    exit;
  end;
  if not (Key in ['0'..'9', #8]) then
  begin
    Key := #0;
    beep;
  end;
}
end;

procedure TfrmOptionsOther.spnImagingMaxClick(Sender: TObject;
  Button: TUDBtnType);
begin
{  txtImagingMax.SetFocus;
  txtImagingMax.Tag := strtointdef(txtImagingMax.Text, 0);
  btnImagingDefaults.Tag := 0;
  AdjustImagingLabel;
}
end;

procedure TfrmOptionsOther.btnImagingDefaultsClick(Sender: TObject);
begin
{  txtImagingMax.Text := inttostr(spnImagingMax.Tag);
  spnImagingMaxClick(self, btNext);
  txtImagingStart.Tag := spnImagingStart.Tag - 1;
  spnImagingStartClick(self, btNext);
  txtImagingStop.Tag := spnImagingStop.Tag - 1;
  spnImagingStopClick(self, btNext);
  btnImagingDefaults.Tag := 1;
}
end;

procedure TfrmOptionsOther.txtImagingStartExit(Sender: TObject);
begin
{  with txtImagingStart do
  if Text = '' then
  begin
    Text := 'T-1';
    Hint := 'T-1';
    spnImagingStartClick(self, btNext);
  end;
  TextExit(txtImagingStart, FStartEntered, spnImagingStart.Max);
  AdjustImagingLabel;
}
end;

procedure TfrmOptionsOther.txtImagingStartKeyPress(Sender: TObject;
  var Key: Char);
begin
{  if key = #13 then
  begin
    FStartEntered := true;
    Perform(WM_NextDlgCtl, 0, 0);
  end;
}
end;

procedure TfrmOptionsOther.txtImagingStartKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
{  txtImagingStart.Hint := txtImagingStart.Text;   // put text in hint since text not available to spin
  FStartEntered := true;
}
end;

procedure TfrmOptionsOther.spnImagingStartClick(Sender: TObject;
  Button: TUDBtnType);
begin
{  with txtImagingStart do
  begin
    if FStartEntered then
    begin
      if Hint = '' then Hint := 'T';
      tagnum := RelativeDate(Hint);
      if tagnum = INVALID_DAYS then
      begin
        Text := Hint;
        beep;
        MessageDlg('Start Date entry was invalid', mtWarning, [mbOK], 0);
        ShowDisplay(txtImagingStart);
        FStartEntered := false;
        exit;
      end
      else
      begin
        DateLimits(spnImagingStart.Max, tagnum);
        if tagnum <> INVALID_DAYS then
          Tag := tagnum;
      end;
    end;
    SetFocus;
    if Button = btNext then tagnum := Tag + 1
    else tagnum := Tag - 1;
    Text := Hint;
    DateLimits(spnImagingStart.Max, tagnum);
    if tagnum <> INVALID_DAYS then
      Tag := tagnum;
    ShowDisplay(txtImagingStart);
  end;
  btnImagingDefaults.Tag := 0;
  AdjustImagingLabel;
  FStartEntered := false;
}
end;

procedure TfrmOptionsOther.txtImagingStopExit(Sender: TObject);
begin
{  with txtImagingStop do
  if Text = '' then
  begin
    Text := 'T-1';
    Hint := 'T-1';
    spnImagingStopClick(self, btNext);
  end;
  TextExit(txtImagingStop, FStopEntered, spnImagingStart.Max);
  AdjustImagingLabel;
}
end;

procedure TfrmOptionsOther.txtImagingStopKeyPress(Sender: TObject;
  var Key: Char);
begin
{  if key = #13 then
  begin
    FStopEntered := true;
    Perform(WM_NextDlgCtl, 0, 0);
  end;
}
end;

procedure TfrmOptionsOther.txtImagingStopKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
{  txtImagingStop.Hint := txtImagingStop.Text;   // put text in hint since text not available to spin
  FStopEntered := true;
}
end;

procedure TfrmOptionsOther.spnImagingStopClick(Sender: TObject;
  Button: TUDBtnType);
begin
{  with txtImagingStop do
  begin
    if FStopEntered then
    begin
      if Hint = '' then Hint := 'T';
      tagnum := RelativeDate(Hint);
      if tagnum = INVALID_DAYS then
      begin
        Text := Hint;
        beep;
        MessageDlg('Stop Date entry was invalid', mtWarning, [mbOK], 0);
        ShowDisplay(txtImagingStop);
        FStopEntered := false;
        exit;
      end
      else
      begin
        DateLimits(spnImagingStart.Max, tagnum);
        if tagnum = INVALID_DAYS then
        begin
          Text := Hint;
          ShowDisplay(txtImagingStop);
          FStopEntered := false;
          exit;
        end;
      end;
    end;
    SetFocus;
    if Button = btNext then tagnum := Tag + 1
    else tagnum := Tag - 1;
    Text := Hint;
    DateLimits(spnImagingStart.Max, tagnum);
    if tagnum <> INVALID_DAYS then
      Tag := tagnum;
    ShowDisplay(txtImagingStop);
  end;
  btnImagingDefaults.Tag := 0;
  AdjustImagingLabel;
  FStopEntered := false;
}
end;

{procedure TfrmOptionsOther.AdjustImagingLabel;
var
  maxnum, start, stop: string;
begin
  maxnum := txtImagingMax.Text;
  start := txtImagingStart.Text;
  stop := txtImagingStop.Text;
  if start <> 'Today' then start := start + ' days';
  if stop <> 'Today' then stop := stop + ' days';

  lblImagingDesc.Caption := 'Use these settings to limit the number of imaging reports '
                         +  'that can be displayed on the Reports tab. '
                         +  'Reports will be limited to ' + maxnum
                         +  ' within the date range of ' + start + ' to ' + stop + '.'

end;
}

end.
