unit frmAssignPrvTeam;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ORCtrls, ExtCtrls, Menus, VA508AccessibilityManager;

type
  TfrmP = class(TForm)
    Panel3: TPanel;
    cboHOProvider: TORComboBox;
    lbxHOProvider2: TORListBox;
    pnlProvInfo: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    cboUserClass: TORComboBox;
    ppProviderDelete: TPopupMenu;
    MenuItem1: TMenuItem;
    Panel1: TPanel;
    pnlMid: TORAutoPanel;
    btnProviderAdd: TORAlignButton;
    btnProviderRemove: TORAlignButton;
    edtPhone: TORAlignEdit;
    edtPager: TORAlignEdit;
    btnPrvSaveInfo: TORAlignButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    SubmitData1: TMenuItem;
    Exit1: TMenuItem;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    Panel2: TPanel;
    mmfilename: TMemo;
    edtfilename: TEdit;
    procedure edtfilenameExit(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cboHOProviderNeedData(Sender: TObject;
      const StartFrom: String; Direction, InsertAt: Integer);
    procedure cboHOProviderDblClick(Sender: TObject);
    procedure btnProviderAddClick(Sender: TObject);
    procedure btnProviderRemoveClick(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure btnPrvSaveInfoClick(Sender: TObject);
    procedure lbxHOProvider2Click(Sender: TObject);
    procedure cboUserClassKeyPress(Sender: TObject; var Key: Char);
    procedure cboUserClassChange(Sender: TObject);
    procedure edtPhoneChange(Sender: TObject);
    procedure edtPagerChange(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    ProviderChanged : Boolean;
    ProviderInfoChanged : Boolean;
    UserInfo : TStrings;
    indx : integer;
    ProvClass : String;
    OPhone : String;
    Pager : String;
    resetfldflag : Boolean;
    Procedure ProviderInfo(TM,DUZ : String; ind : integer);
    procedure DisableSwitchPrvFlds(value : Boolean);
  public
    { Public declarations }
    Team : String;

  end;

var
  frmP: TfrmP;

Procedure AssignProvidersToATeam(TM : String);

implementation

{$R *.DFM}

Uses ORfn, ORNet, rcore, Util, frmMain, frmHOListSetup;

Procedure AssignProvidersToATeam(TM : String);
var
frmAPrv : TfrmP;
s : String;
begin
 frmAPrv := TfrmP.Create(Application);
 Try
 with frmAPrv do
 begin
   Team := TM;
   caption := piece(TM,'^',2);
   lbxHOProvider2.Items.Clear;
   If UserInfo = nil then UserInfo := TStringList.Create;
   DisableSwitchPrvFlds(False);

   if pos('HOTEAM',TM)= 0 then
     begin
      tCallV(lbxHOProvider2.Items,'CRHD TM PRV LIST', [TM]);
      lbxHOProvider2.ItemIndex := -1;
      edtfilename.text := sCallV('CRHD GET TEAM FILENAME', [TM]);
     end
    else
      if pos('HOTEAM',TM)> 0 then
      begin
       s := sCallV('CRHD HOT CAN EDIT',[TM, frmListSelect.DUZ]) ;
       if piece(s,'^',2)= '1' then
        begin
        tCallV(lbxHOProvider2.Items,'CRHD HOT PROVIDER LIST', [TM]);
        edtfilename.text := sCallV('CRHD GET TEAM FILENAME', [TM]);
        end
       else
        begin
          showmessage('You are not authorized to edit this list');
          exit;
        end;
     end;



  if lbxHOProvider2.Items.Count > 0 then
   begin
    UserInfo.AddStrings(lbxHOProvider2.Items);

    if lbxHOProvider2.Items.Count > 0 then
     if lbxHOProvider2.Items[0] <> 'No list found' then
     begin
     lbxHOProvider2.ItemIndex :=0 ;
     lbxHOProvider2Click(lbxHOProvider2);
     btnProviderRemove.enabled := True;
     indx := 0;
     end
     else
     lbxHOProvider2.Clear;
     end;

   ShowModal;
  end;
 finally
  frmAPrv.Free;
end;
end;

procedure TfrmP.FormClose(Sender: TObject; var Action: TCloseAction);
begin
close;
end;

procedure TfrmP.FormCreate(Sender: TObject);
begin
Font := frmListSelect.Font;

case Font.Size of
   8..12 : begin
             pnlMid.Width := 102;
             pnlProvInfo.Width := 150;
           end;
   18    : begin
             pnlMid.Width := 168;
             pnlProvInfo.Width := 155;
           end;
   24    : begin
             pnlMid.Width := 208;
             pnlProvInfo.Width := 205;
           end;
end;

with cboHOProvider do
 begin
  ListItemsOnly := true;
  LongList := true;
  InitLongList('');
 end;
end;

procedure TfrmP.FormDestroy(Sender: TObject);
begin
 if Assigned(UserInfo) then FreeAndNil(UserInfo);

end;

procedure TfrmP.cboHOProviderNeedData(Sender: TObject;
  const StartFrom: String; Direction, InsertAt: Integer);
begin
cboHOProvider.ForDataUse(SubSetOfPersons(StartFrom, Direction));
end;

procedure TfrmP.cboHOProviderDblClick(Sender: TObject);
begin
btnProviderAddClick(btnProviderAdd);
end;

procedure TfrmP.btnProviderAddClick(Sender: TObject);
var
pstr : string;
begin
if (cboHOProvider.ItemIndex > -1) and (not findDup(piece(cboHOProvider.Items[cboHOProvider.ItemIndex],'^',1),lbxHOProvider2.Items) ) then
 begin
  indx := lbxHOProvider2.Items.Add(cboHOProvider.items[cboHOProvider.itemindex]);
  if indx > -1 then lbxHOProvider2.ItemIndex := indx;
  if UserInfo = nil then UserInfo := TStringList.Create;
  DisableSwitchPrvFlds(True);
  ProviderChanged := True;
  ProviderInfo(Team, cboHOProvider.Items[cboHOProvider.ItemIndex], lbxHOProvider2.ItemIndex );

  pstr := sCALLV('CRHD USER PHONE NUMBERS',[cboHOProvider.Items[cboHOProvider.ItemIndex]]);
  if edtPhone.Text = '' then
    begin
    edtPhone.Text := piece(pstr,'^',1);
    lbxHOProvider2.Items[indx] :=piece(lbxHOProvider2.Items[indx],'^',1)+ '^' + piece(lbxHOProvider2.Items[indx], '^',2)+ '^' + piece(lbxHOProvider2.Items[indx], '^',3) + '^' + piece(lbxHOProvider2.Items[indx], '^',4) + '^' + piece(lbxHOProvider2.Items[indx], '^',5)+ '^' + edtPhone.Text + '^' + piece(lbxHOProvider2.Items[indx], '^',7) ;
    end;
  if edtPager.Text = '' then
    begin
    edtPager.Text := piece(pstr,'^',2);
    lbxHOProvider2.Items[indx] := piece(lbxHOProvider2.Items[indx],'^',1)+ '^' + piece(lbxHOProvider2.Items[indx], '^',2)+ '^' + piece(lbxHOProvider2.Items[indx], '^',3) + '^' + piece(lbxHOProvider2.Items[indx], '^',4) + '^' + piece(lbxHOProvider2.Items[indx], '^',5)+ '^' + piece(lbxHOProvider2.Items[indx], '^',6)+ '^' + edtPager.Text;
    end;

  ProviderChanged := True;

  btnPrvSaveInfo.Enabled := True;
  if not btnProviderRemove.Enabled then btnProviderRemove.Enabled:= True;
  if ProviderChanged then btnPrvSaveInfo.Enabled := True;

  if cboUserClass.ItemIndex > -1 then pstr := cboUserClass.Items[cboUserClass.itemIndex]
  else pstr := '';
  end;
end;

procedure TfrmP.btnProviderRemoveClick(Sender: TObject);
begin
if lbxHOProvider2.ItemIndex > -1 then
  begin
   indx := CurrentIndex(lbxHOProvider2.ItemIndex,lbxHOProvider2.Items.count);
   UserInfo.Delete(lbxHOProvider2.ItemIndex);
   lbxHOProvider2.Items.Delete(lbxHOProvider2.ItemIndex);
   lbxHOProvider2.ItemIndex := indx;
   DisableSwitchPrvFlds(False);
   lbxHOProvider2Click(lbxHOProvider2);
   ProviderChanged := True;

   if lbxHOProvider2.Items.Count = 0 then btnProviderRemove.Enabled := False;
   btnPrvSaveInfo.Enabled := True;
  end;
end;

procedure TfrmP.MenuItem1Click(Sender: TObject);
begin
btnProviderRemoveClick(btnProviderRemove);
end;

procedure TfrmP.btnPrvSaveInfoClick(Sender: TObject);
begin
If (ProviderInfoChanged) or (ProviderChanged) then
  begin
     if pos('HOTEAM',Team)=0 then
     begin
     CallV('CRHD MOD TM PROVIDERS', [Team, lbxHOProvider2.Items, 1]);
     
     CallV('CRHD SAVE TEAM FILENAME', [Team, edtfilename.Text]);
     ProviderInfoChanged := False;
     btnPrvSaveInfo.Enabled := False;
     end
     else
     if pos('HOTEAM',Team)>0 then
     begin
      fHOListSetup.SubmitDataToVista(Team,'D', '1', lbxHOProvider2.Items );
      CallV('CRHD SAVE TEAM FILENAME', [Team, edtfilename.Text]);
     end;
  end;
close;
end;

procedure TfrmP.lbxHOProvider2Click(Sender: TObject);
begin
if not btnProviderRemove.Enabled then btnProviderRemove.Enabled := True;
indx := lbxHOProvider2.ItemIndex;
DisableSwitchPrvFlds(True);
if lbxHOProvider2.ItemIndex > -1 then ProviderInfo(Team, lbxHOProvider2.Items[lbxHOProvider2.ItemIndex],lbxHOProvider2.ItemIndex );
if Not ProviderChanged then btnPrvSaveInfo.Enabled := False;
end;


procedure TfrmP.cboUserClassKeyPress(Sender: TObject; var Key: Char);
begin
ProviderInfoChanged := True;
btnPrvSaveInfo.Enabled := True;
end;

procedure TfrmP.ProviderInfo(TM, DUZ: String; ind: integer);
  Procedure clearflds;
   begin
     cboUserClass.Text := '';
     cboUserClass.ItemIndex :=-1;
     edtPhone.Text := '';
     edtPager.Text :=  '';
   end;

var
sPrv, vPrv,vstr : String;
vPM, vDm : String;
begin
  if UserInfo = nil then UserInfo := TStringList.Create;
  clearflds;
   vPrv := lbxHOProvider2.Items[lbxHOProvider2.ItemIndex];
   if pos(piece(vPrv,'^',3),'ATTN^RES^INTERN^FELLOW^MED STUDENT^NURSE')= 0 then
     vPrv := piece(vPrv,'^',1)+ '^' + piece(vPrv, '^',2)+ '^' + '' + '^' + piece(vPrv,'^',4) + '^' + piece(vPrv, '^',5)+ '^' + piece(vPrv,'^',6) + '^' + piece(vPrv, '^',7) ;


   sPrv := sCallV('CRHD TM PRV INFO', [TM, piece(lbxHOProvider2.Items[lbxHOProvider2.ItemIndex],'^',1)]);


    if piece(vPrv,'^',6) <> '' then edtPhone.Text := piece(vPrv,'^',6)
    else edtPhone.Text := piece(sPrv,'^',6);

    if piece(vPrv,'^',7) <> '' then edtPager.Text := piece(vPrv,'^',7)
    else edtPager.Text := piece(sPrv,'^',7);

   cboUserClass.Text := piece(vPrv,'^',3);

   if pos(piece(vPrv,'^',3),'ATTN^RES^INTERN^FELLOW^MED STUDENT^NURSE')= 0 then
     if pos(piece(sPrv,'^',3),'ATTN^RES^INTERN^FELLOW^MED STUDENT^NURSE')> 0 then
      begin
      cboUserClass.Text := piece(sPrv,'^',3);
      end
      else
      cboUserClass.Text := '';


    if piece(vPrv,'^',4) <> '' then vPM := piece(vPrv,'^',4)
    else vPM := piece(sPrv,'^',4);
    if vPM = '' then vPM := '0';

    if piece(vPrv,'^',5) <> '' then vDM := piece(vPrv,'^',5)
    else vDM := piece(sPrv,'^',5);
    if vDM = '' then vDM := '0';

     vstr :=  piece(vPrv,'^',1) + '^' + piece(vPrv,'^',2)+ '^'+ cboUserClass.Text + '^' + vPM + '^' + vDM + '^' +  edtPhone.Text + '^' + edtPager.Text;

if indx > -1 then  lbxHOProvider2.Items[indx]:= vstr;

    ProviderInfoChanged := False;
end;

procedure TfrmP.cboUserClassChange(Sender: TObject);
var
str3 : String;
begin
  if Not resetfldflag then
   begin
     ProviderInfoChanged := True;
     ProvClass := cboUserClass.Text;
     if lbxHOProvider2.Items.Count > 0 then
        begin
          str3 :=piece(lbxHOProvider2.Items[indx],'^',1)+ '^' + piece(lbxHOProvider2.Items[indx], '^',2)+ '^' + ProvClass + '^' + piece(lbxHOProvider2.Items[indx], '^',4) + '^' + piece(lbxHOProvider2.Items[indx], '^',5)+ '^' + piece(lbxHOProvider2.Items[indx], '^',6) + '^' + piece(lbxHOProvider2.Items[indx], '^',7) ;
          lbxHOProvider2.Items[indx] := str3;
          ProviderChanged := True;
          btnPrvSaveInfo.Enabled := True;
        end;
   end;
end;

procedure TfrmP.edtPhoneChange(Sender: TObject);
var
str3 : String;
begin
  if Not resetfldflag then
    begin
      OPhone := edtPhone.Text;
      str3 :=piece(lbxHOProvider2.Items[indx],'^',1)+ '^' + piece(lbxHOProvider2.Items[indx], '^',2)+ '^' + piece(lbxHOProvider2.Items[indx], '^',3) + '^' + piece(lbxHOProvider2.Items[indx], '^',4) + '^' + piece(lbxHOProvider2.Items[indx], '^',5)+ '^' + OPhone + '^' + piece(lbxHOProvider2.Items[indx], '^',7) ;
      lbxHOProvider2.Items[indx] := str3;
      ProviderChanged := True;
      btnPrvSaveInfo.Enabled := True;
   end;
end;

procedure TfrmP.Exit1Click(Sender: TObject);
begin
Close;
end;

procedure TfrmP.edtfilenameExit(Sender: TObject);
var
fn : string;
begin
fn := ExtractFilename(edtfilename.Text);
if pos('.', fn)>0 then fn := piece(fn,'.',1);

if not IsvalidWindowsfilename(fn) then
begin
 showmessage('NOT VALID FILENAME...TRY AGAIN');
 edtfilename.SetFocus;
end;
end;

procedure TfrmP.edtPagerChange(Sender: TObject);
var
str3 : String;
begin
   if Not resetfldflag then
    begin
     Pager := edtPager.Text;
     str3 :=piece(lbxHOProvider2.Items[indx],'^',1)+ '^' + piece(lbxHOProvider2.Items[indx], '^',2)+ '^' + piece(lbxHOProvider2.Items[indx], '^',3) + '^' + piece(lbxHOProvider2.Items[indx], '^',4) + '^' + piece(lbxHOProvider2.Items[indx], '^',5)+ '^' + piece(lbxHOProvider2.Items[indx], '^',6)+ '^' + Pager ;
     lbxHOProvider2.Items[indx] := str3;
     ProviderChanged := True;
     btnPrvSaveInfo.Enabled := True;
    end;
end;

procedure TfrmP.DisableSwitchPrvFlds(value: Boolean);
begin
    resetfldflag := True;
    cboUserClass.Text := '';
    cboUserClass.ItemIndex := -1;
    cboUserClass.Enabled := Value;
    edtPhone.Text := '';
    edtPhone.Enabled := Value;
    edtPager.Text := '';
    edtPager.Enabled := Value;
    Label1.Enabled := Value;
    Label2.Enabled := Value;
    Label3.Enabled := Value;
    resetfldflag := False;
end;

procedure TfrmP.FormResize(Sender: TObject);
var
h : integer;
begin
 h := Trunc(pnlMid.Height / 2);
 btnProviderRemove.Height := h;

 h := Trunc((Panel3.Width - pnlMid.Width - pnlProvInfo.Width)/2);
 cboHOProvider.Width := h;
 lbxHOProvider2.Width := h;
end;

end.
