unit frmHOTeamSelect;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ORCtrls, ExtCtrls, StdCtrls, Menus, VA508AccessibilityManager;

type
  TfrmHOSelectTeam = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    cbxHOTeam: TORComboBox;
    Panel5: TPanel;
    ppTeamSelect: TPopupMenu;
    DeleteTeam1: TMenuItem;
    btnExit: TORAlignButton;
    Button1: TORAlignButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    procedure FormCreate(Sender: TObject);
    procedure cbxHOTeamDblClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure DeleteTeam1Click(Sender: TObject);
    procedure cbxHOTeamKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnExitClick(Sender: TObject);
  private
    { Private declarations }
    function AddNewTeamName(TeamName: String; vList: TStrings): integer;
  public
    { Public declarations }
  end;

var
  frmHOSelectTeam: TfrmHOSelectTeam;

procedure HOTeamSelectP;

implementation

{$R *.DFM}

uses ORNet, Orfn, frmHOListSetup, Util, frmMain;

//HOTeamSelect Section --------------------------------------
procedure HOTeamSelectP;
var
frmHOTeamSelect : TfrmHOSelectTeam;
begin
  frmHOTeamSelect := TfrmHOSelectTeam.Create(Application);
  try
    frmHOTeamSelect.ShowModal;
  finally
    frmHOTeamSelect.Free;
  end;
end;

procedure TfrmHOSelectTeam.FormCreate(Sender: TObject);
var
  mlist: TStrings;
begin

  Font := frmListSelect.Font;

  mlist := TStringList.Create;
  try
    cbxHOTeam.Clear;
    tCallV(mlist, 'CRHD HOT TEAM LIST', [nil]);
    if mlist.count > 0 then
    begin
      if piece(mlist[0], '^', 2) = 'No List Found' then
        exit
      else
        cbxHOTeam.Items.AddStrings(mlist);
    end;
  finally
    mlist.Free;
  end;
end;

procedure TfrmHOSelectTeam.cbxHOTeamDblClick(Sender: TObject);
var
s : String;
begin
  if cbxHOTeam.Text = 'No List Found' then exit;
  s := sCallV('CRHD HOT CAN EDIT',[cbxHOTeam.Items[cbxHOTeam.ItemIndex] , frmListSelect.DUZ]) ;
  if s = '0^0' then
    begin
     ShowMessage('You have No access to this List...Please contact IMS for access');
     exit;
    end;
  HOListSetupP(cbxHOTeam.Items[cbxHOTeam.ItemIndex]);
end;

function TfrmHOSelectTeam.AddNewTeamName(TeamName: String; vList: TStrings): integer;
var
vstr : String;
ien : integer;

begin
  Result := 0;

  if not findDup(TeamName,vList) then
  begin
     vstr := sCallV('CRHD HOT TEAM SAVE', [TeamName]);
     ien := StrToInt(vstr);
     if ien > 0 then Result := vList.Add(vstr + '^' + TeamName + '^HOTEAM')
     else
       begin
         showmessage('Could not Save Team, Please try a different spelling');
         cbxHOTeam.Text := '';
       end;
   end;
end;

procedure TfrmHOSelectTeam.Button1Click(Sender: TObject);
var
nien : integer;
MGRkey : integer;
begin

  If (cbxHOTeam.ItemIndex <0) and (cbxHOTeam.Text<> '') then
  begin
       MGRkey := StrToInt(sCallV('CRHD HOT TEAM MGR',[frmListSelect.DUZ]));
       if MGRkey < 1 then
        begin
         ShowMessage('You need "CRHD HOT TEAM MGR" key to Add new Teams...Please contact IMS for access');
         cbxHOTeam.Text := '';
         exit;
        end;
       if MessageDlg('Do you want to Save ' + cbxHOTeam.Text + ' as a New Team?',
         mtConfirmation, [mbYes, mbNo], 0) = mrNo then cbxHOTeam.Text := ''
       else
          begin
            nien := AddNewTeamName(cbxHOTeam.Text, cbxHOTeam.items);
            if nien > -1 then cbxHOTeam.ItemIndex := nien;
            if cbxHOTeam.Items.Count > 0 then
               if (nien > -1) and (nien < cbxHOTeam.Items.Count) then
                begin
                  cbxHOTeam.Text := piece(cbxHOTeam.Items[nien],'^',2);
                  cbxHOTeam.ItemIndex := nien;
                  HOListSetupP(cbxHOTeam.Items[cbxHOTeam.ItemIndex]);
                end;
          end;
  end
  //end
     else
     if (cbxHOTeam.ItemIndex > -1) then HOListSetupP(cbxHOTeam.Items[cbxHOTeam.ItemIndex]);
end;

procedure TfrmHOSelectTeam.DeleteTeam1Click(Sender: TObject);
var
vstr : String;
i : integer;
begin
  if cbxHOTeam.ItemIndex > -1 then
  begin
    i := CurrentIndex(cbxHOTeam.ItemIndex, cbxHOTeam.Items.Count);
    vstr := sCallV('CRHD HOT DELETE TEAM LIST', [cbxHOTeam.Items[cbxHOTeam.ItemIndex]]);
    cbxHOTeam.Items.Delete(cbxHOTeam.ItemIndex);
    cbxHOTeam.ItemIndex := i;
  end;
end;

procedure TfrmHOSelectTeam.cbxHOTeamKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
If Key = VK_RETURN then Button1Click(Button1);
end;

procedure TfrmHOSelectTeam.btnExitClick(Sender: TObject);
begin
Close;
end;

end.
