unit frmPrintReport;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, RpRave, RpDefine, RpBase, RpSystem, RpCon, StdCtrls, Util, RpDevice,
  RVData;

type
  TfrmReportM = class(TForm)
    RvSystem1: TRvSystem;
    RvProject: TRvProject;
    RvCConnection: TRvCustomConnection;
    procedure RvCConnectionOpen(Connection: TRvCustomConnection);
    procedure RvCConnectionGetRow(Connection: TRvCustomConnection);
    procedure RvCConnectionGetCols(Connection: TRvCustomConnection);
    procedure RvProjectCreate(Sender: TObject);
    procedure RvCConnectionFirst(Connection: TRvCustomConnection);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    TitlesNum: integer;
    function GetTeamName(ListNm: String): String;
    function GetUserContactInfo(User: String): String;
    Procedure GetContactInfo(ListNm: String;
      MainContact, OtherContact: TStringList);
    function GetPatDemo(indx: integer; PatDemo: TStringList): String;
    Procedure GetAllergies(indx: integer; RtnLst: TStringList);
    Procedure GetCodeStatus(indx: integer; RtnLst: TStringList);
    function GetCoveringPhy(indx: integer): String;
    Procedure GetMedication(indx: integer; Med1, Med2: TStringList);
    procedure GetData(Lst: TStringList; RPC, value: String);
    procedure GetTempfld(indx: integer; fldname: String; RtnLst: TStringList);
    procedure SizeProcess(PL: String);
    Function PrintText(TextToPrint: string): string;
  public
    { Public declarations }
    XM: Boolean;
    ListName: String;
    SomeList: TStrings;
    ListTitle: String;
    Procedure SortList(Slist, rlist: TStrings; flg: String);
    Procedure PrintMyReport(ListNme: String);
  end;

var
  frmReportM: TfrmReportM;
  PatArray: array of String;
  ListN: array of String;

implementation

{$R *.dfm}

uses Orfn, OrNet, frmMain, frmPrintData;

const
  MAX_CHAR_PRINT = 750;

  // ==============================================================================
  // Modified By:   ZZZZZZBELLC
  // DateTime:      2017.1.3
  // Description:
  // (1) Update parameter(s) to take in the return list and remove
  // the return.
  // (2) Move this from a function to a procedure
  // ==============================================================================
procedure TfrmReportM.FormDestroy(Sender: TObject);
begin
 if Assigned(SomeList) then FreeAndNil(SomeList);
end;

procedure TfrmReportM.GetAllergies(indx: integer; RtnLst: TStringList);
begin
  RtnLst.Clear;
  GetData(RtnLst, 'CRHD PAT ALLERGIES', piece(PatArray[indx], '^', 1) +
    '^' + '0^0');
  if RtnLst.count > 0 then
    RtnLst.Delete(0);
end;

// ==============================================================================
// Modified By:   ZZZZZZBELLC
// DateTime:      2017.1.3
// Description:
// (1) Update parameter(s) to take in the return list and remove
// the return.
// (2) Move this from a function to a procedure
// ==============================================================================
procedure TfrmReportM.GetCodeStatus(indx: integer; RtnLst: TStringList);
var
  uDiv: String;
begin
  RtnLst.Clear;
  if (pos('^DIV', frmListSelect.Pref) > 0) or
    (pos(';DIC(4,', frmListSelect.Pref) > 0) then
    uDiv := piece(piece(frmListSelect.Pref, '^', 2), ';', 1)
  else
    uDiv := piece(frmListSelect.vDiv, '^', 1);

  GetData(RtnLst, 'CRHD PAT CODESTS', piece(PatArray[indx], '^', 1) + '^' + '^'
    + piece(frmListSelect.vDiv, '^', 1) + '^256^1^' +
    IntToStr(frmListSelect.UserPar.MULTI_DNR));

  if RtnLst.count > 0 then
    RtnLst.Delete(0);

end;

// ==============================================================================
// Modified By:   ZZZZZZBELLC
// DateTime:      2017.8.14
// Description:
// (1) Clean up variables (StrList being freed twice)
// ==============================================================================
procedure TfrmReportM.GetContactInfo(ListNm: String;
  MainContact, OtherContact: TStringList);
var
  str1, str2, ph: String;
  i, i2, n: integer;
  tmpList: TStringList;
  tmpCList: TStringList;
  tmpCList2: TStringList;
begin
  MainContact.Clear;
  OtherContact.Clear;
  n := 0;

  tmpList := TStringList.Create;
  try

    if (pos('^HOTEAM', ListNm) > 0) then
    begin
      n := 7;
      tCallV(tmpList, 'CRHD HOT PROVIDER LIST', [ListNm]);
    end
    else if (pos('^Combination', ListNm) > 0) then
    begin
      tmpCList := TStringList.Create;
      tmpCList2 := TStringList.Create;
      try
        tCallV(tmpCList, 'CRHD COMB TM LIST', []);
        if tmpCList.count > 0 then
          for i := 0 to tmpCList.count - 1 do
          begin
            tmpCList2.Clear;
            tCallV(tmpCList2, 'CRHD TM PRV LIST', [tmpCList[i]]);
            n := 5;
            if tmpCList2[0] = 'No list found' then
              tmpCList2.Clear;
            if tmpCList2.count > 0 then
              for i2 := 0 to tmpCList2.count - 1 do
                if not findDup(piece(tmpCList2[i2], '^', 2), tmpList) then
                  tmpList.Append(tmpCList2[i2]);
          end;
      finally
        tmpCList2.Free;
        tmpCList.Free;
      end;
    end
    else
    begin
      tCallV(tmpList, 'CRHD TM PRV LIST', [ListNm]);
      n := 5;
    end;

    if tmpList.count = 1 then
      if tmpList[0] = 'No list found' then
        tmpList.Clear;

    if tmpList.count = 0 then
    begin
      MainContact.AddStrings(frmListSelect.UserPar.RESIDENT);
      OtherContact.AddStrings(frmListSelect.UserPar.STUDENT);
    end;

    if tmpList.count > 0 then
    begin
      MixedCaseByPiece(tmpList, '^', 2);
      for i := 0 to tmpList.count - 1 do
      begin
        str1 := tmpList[i];
        ph := '';
        if (piece(str1, '^', n) <> '') and (piece(str1, '^', n) <> '0') then
          ph := 'Pg: ' + piece(str1, '^', n)
        else if (piece(str1, '^', n - 1) <> '') and
          (piece(str1, '^', n - 1) <> '0') then
          ph := 'Ph: ' + piece(str1, '^', n - 1);

        if (ph = 'Pg: ') or (ph = 'Ph: ') then
          ph := '';
        if piece(str1, '^', 3) <> '' then
          str2 := format('%s (' + copy(piece(str1, '^', 3), 1, 1) + ')  %s',
            [piece(str1, '^', 2), ph])
        else
          str2 := format('%s %s', [piece(str1, '^', 2), ph]);

        if piece(str1, '^', 3) = 'ATTN' then
          MainContact.Add(str2);
        if piece(str1, '^', 3) = 'RES' then
          MainContact.Add(str2);
        if piece(str1, '^', 3) = 'INTERN' then
          MainContact.Add(str2);
        if piece(str1, '^', 3) = 'FELLOW' then
          MainContact.Add(str2);
        if piece(str1, '^', 3) = 'MED STUDENT' then
          OtherContact.Add(str2);
        if piece(str1, '^', 3) = 'NURSE' then
          OtherContact.Add(str2);
        if piece(str1, '^', 3) = '' then
          OtherContact.Add(str2);
      end;
    end;
  finally
    tmpList.Free;
  end;
end;

// =============================================================================
// Modified By:   ZZZZZZBELLC
// DateTime:      2017.8.14
// Description:
// (1) Clean up variables - Extra stringlist
// =============================================================================
function TfrmReportM.GetCoveringPhy(indx: integer): String;
var
  xlist: TStringList;
begin
  xlist := TStringList.Create;
  try
    GetData(xlist, 'CRHD GET TEMP FLD', 'Covering Physician' + '^' +
      frmListSelect.DUZ + '^' + piece(PatArray[indx], '^', 1) + '^30^' +
      frmListSelect.vDiv);
    if xlist.count > 1 then
    begin
      xlist.Delete(0);
      if xlist[0] <> '' then
        Result := 'C_Phy: ' + xlist[0];
    end;
  finally
    xlist.Free;
  end;
end;

// =============================================================================
// Modified By:   ZZZZZZBELLC
// DateTime:      2017.8.14
// Description:
// (1) Filter Strings
// =============================================================================
procedure TfrmReportM.GetData(Lst: TStringList; RPC, value: String);
begin
  if pos('~NOTE DATA~', value) > 0 then
    tCallV(Lst, 'CRHD GET TIU TEXT', [piece(value, '^', 3), ''])
  else
    tCallV(Lst, RPC, [value]);
    FilteredStrings(Lst);
end;

// ==============================================================================
// Modified By:   ZZZZZZBELLC
// DateTime:      2017.1.4
// Description:
// (1) remove the return.
// (2) Move this from a function to a procedure
// (3) Update parameter(s) to take in the return lists and
// remove the return.
// ==============================================================================
procedure TfrmReportM.GetMedication(indx: integer; Med1, Med2: TStringList);
var
  xlist: TStringList;
  i: integer;
  NumCharReturn: String;
begin
  xlist := TStringList.Create;
  try
    Med1.Clear;
    Med2.Clear;

    GetData(xlist, 'CRHD PAT ACTMEDS', piece(PatArray[indx], '^', 1) + '^' +
      'I^' + IntToStr(frmListSelect.UserPar.MED_EXCLUDE_IV) + '^0^0^' +
      IntToStr(frmListSelect.UserPar.MED_DETAIL_FLG) + '^' + '40');

    NumCharReturn := '30';
    if TitlesNum = 4 then
      NumCharReturn := '25';
    if xlist.count > 0 then
      if Length(xlist.Text) > (MAX_CHAR_PRINT * 1.5) then
        GetData(xlist, 'CRHD PAT ACTMEDS', piece(PatArray[indx], '^', 1) + '^' +
          'I^' + IntToStr(frmListSelect.UserPar.MED_EXCLUDE_IV) + '^0^0^' +
          IntToStr(frmListSelect.UserPar.MED_DETAIL_FLG) + '^' + NumCharReturn);

    Med1.Clear;
    Med2.Clear;
    if xlist.count > 0 then
    begin
      xlist.Delete(0);
      if xlist.count > 0 then
        if pos('UNIT DOSE', xlist[0]) > 0 then
          xlist.Delete(0);

      for i := 0 to xlist.count - 1 do
      begin
        if xlist.count < 6 then
          Med1.Add(xlist[i])
        else if i < (xlist.count / 2) then
          Med1.Add(xlist[i])
        else
          Med2.Add(xlist[i]);
      end;
    end;
  finally
    xlist.Free;
  end;
end;

// ==============================================================================
// Modified By:   ZZZZZZBELLC
// DateTime:      2017.1.4
// Description:
// (1) Update parameter(s) to take in the return list and
// remove the return.
// ==============================================================================
function TfrmReportM.GetPatDemo(indx: integer; PatDemo: TStringList): String;
var
  str: String;
begin
  PatDemo.Clear;
  str := pieces(PatArray[indx], '^', 3, 7) + '^' + pieces(PatArray[indx],
    '^', 9, 15);
  PiecesToList(str, '^', PatDemo);
  str := '';
  if pos('^HOTEAM', ListN[0]) > 0 then
  begin
    str := sCallV('CRHD HOT PATPRV', [ListN[0], piece(PatArray[indx], '^', 1)]);
    if piece(str, ';', 2) <> '' then
      PatDemo.Add('A: ' + piece(piece(str, ';', 2), '^', 2));
    if piece(str, ';', 3) <> '' then
      PatDemo.Add('R: ' + piece(piece(str, ';', 3), '^', 2));
    if piece(str, ';', 4) <> '' then
      PatDemo.Add('I: ' + piece(piece(str, ';', 4), '^', 2));
    if piece(str, ';', 5) <> '' then
      PatDemo.Add('F: ' + piece(piece(str, ';', 5), '^', 2));
    if piece(str, ';', 6) <> '' then
      PatDemo.Add('M: ' + piece(piece(str, ';', 6), '^', 2));
    if piece(str, ';', 7) <> '' then
      PatDemo.Add('N: ' + piece(piece(str, ';', 7), '^', 2));
  end;
  Result := piece(PatArray[indx], '^', 8);
end;

function TfrmReportM.GetTeamName(ListNm: String): String;
var
  tmpCList: TStrings;
  i: integer;
begin
  Result := piece(ListNm, '^', 2);

  if (pos('^Combination', ListNm) > 0) then
  begin
    tmpCList := TStringList.Create;
    try
      tCallV(tmpCList, 'CRHD COMB TM LIST', []);
      Result := '';
      if tmpCList.count > 0 then
        for i := 0 to tmpCList.count - 1 do
          Result := Result + piece(tmpCList[i], '^', 2) + ' - ';
    finally
      tmpCList.Free;
    end;
  end;
end;

// ==============================================================================
// Modified By:   ZZZZZZBELLC
// DateTime:      2017.1.3
// Description:
// (1) Update parameter(s) to take in the return list and remove
// the return.
// (2) Move this from a function to a procedure
// ==============================================================================
procedure TfrmReportM.GetTempfld(indx: integer; fldname: String;
  RtnLst: TStringList);
begin
  with frmListSelect.UserPar do
  begin
    GetData(RtnLst, 'CRHD GET TEMP FLD', fldname + '^' + frmListSelect.DUZ + '^'
      + piece(PatArray[indx], '^', 1) + '^' + '256');
    if RtnLst.count > 0 then
      RtnLst.Delete(0);
  end;
end;

function TfrmReportM.GetUserContactInfo(User: String): String;
var
  tmpList: TStrings;
begin
  tmpList := TStringList.Create;
  try
    tmpList.Clear;
    tCallV(tmpList, 'CRHD ADDITIONAL USER INFO', [User]);
    if tmpList.count > 0 then
    begin
      if piece(tmpList[0], '^', 2) <> '' then
        Result := Result + ' Pager: ' + piece(tmpList[0], '^', 2)
      else if piece(tmpList[0], '^', 1) <> '' then
        Result := Result + ' Office Ph: ' + piece(tmpList[0], '^', 1)
    end;
  finally
    tmpList.Free;
  end;
end;

procedure TfrmReportM.PrintMyReport(ListNme: String);
var
  i: integer;
begin
  SetLength(PatArray, SomeList.count);
  for i := 0 to SomeList.count - 1 do
    PatArray[i] := SomeList[i];

  SetLength(ListN, 1);
  ListN[0] := ListNme;
  RPDev.SetPaperSize(DMPAPER_LETTER, 0, 0);
  RvProject.Execute;
end;

procedure TfrmReportM.RvCConnectionFirst(Connection: TRvCustomConnection);
var
 test:String;
begin
 test := '';
end;

procedure TfrmReportM.RvCConnectionGetCols(Connection: TRvCustomConnection);
begin
  With Connection do
  begin
    WriteField('ListName', dtString, 30, 'ListName', '');
    WriteField('User', dtString, 30, 'User', '');
    WriteField('UserContact', dtString, 50, 'UserContact', '');
    WriteField('Contact1', dtMemo, 500, 'Contact1', '');
    WriteField('Contact2', dtMemo, 500, 'Contact2', '');
    WriteField('PatientName', dtString, 30, 'PatientName', '');
    WriteField('SSN', dtString, 15, 'SSN', '');
    WriteField('PatDemo', dtMemo, 500, 'Patient Info', '');
    WriteField('Allergies', dtMemo, 500, 'Allergies', '');
    WriteField('CodeStatus', dtMemo, 500, 'CodeStatus', '');
    WriteField('Medication', dtMemo, 500, 'Meds', '');
    if XM then
      WriteField('Medication2', dtMemo, 500, 'Meds2', '');
    WriteField('CoveringPhy', dtString, 30, 'CoveringPhy', '');
    WriteField('lblTemp1', dtString, 15, 'lblTemp1', '');
    WriteField('lblTemp2', dtString, 15, 'lblTemp2', '');
    WriteField('lblTemp3', dtString, 15, 'lblTemp3', '');
    WriteField('lblTemp4', dtString, 15, 'lblTemp4', '');
    if frmListSelect.UserPar.TEMP_FLD_1_TITLE <> '' then
      WriteField('Temp1', dtMemo, 500, 'Temp1', '');
    if frmListSelect.UserPar.TEMP_FLD_2_TITLE <> '' then
      WriteField('Temp2', dtMemo, 500, 'Temp2', '');
    if frmListSelect.UserPar.TEMP_FLD_3_TITLE <> '' then
      WriteField('Temp3', dtMemo, 500, 'Temp3', '');
    if frmListSelect.UserPar.TEMP_FLD_4_TITLE <> '' then
      WriteField('Temp4', dtMemo, 500, 'Temp4', '');
  end;
end;

{ Order of write
  'ListName',dtString,30-'User',dtString,30-'UserContact',dtString,50
  'Contact1',dtMemo,500-'Contact2',dtMemo,500-'PatDemo1', dtMemo, 500
  'PatDemo2', dtMemo, 500-'Allergies',dtMemo, 500-'CodeStatus',dtMemo,500
  'Medication',dtMemo,500-'CoveringPhy',dtString,30-'lblTemp1',dtString,15
  'lblTemp2',dtString,15-'lblTemp3',dtString,15-'lblTemp4',dtString,15
  'Temp1',dtMemo,500-'Temp2',dtMemo,500-'Temp3',dtMemo,500-'Temp4',dtMemo,500 }

// ==============================================================================
// Modified By:   ZZZZZZBELLC
// DateTime:      2017.1.3
// Description:
// (1) Update tList to RPCReturnList variable name and make it a
// TStringList
// (2) Added a free to the stringlist with a Try/Finally block
// (3) Added new WriteBlobToReport function and rewrote the
// buffer code
// ==============================================================================

procedure TfrmReportM.RvCConnectionGetRow(Connection: TRvCustomConnection);
var
  i, n, nx: integer;
  str, str2, ph: String;
  RPCReturnList, TmpStrLst: TStringList;
  ov, TmpStr: String;

  Procedure WriteBlobToReport(aStrLst: TStringList;
    ReplaceLineBreak: Boolean = false);
  var
    Size: integer;
    Buffer: PAnsiChar;
  begin
    if not assigned(aStrLst) then
      exit;

    // need to setup max length
    if Length(aStrLst.Text) > MAX_CHAR_PRINT then
      aStrLst.Text := copy(aStrLst.Text, 1, MAX_CHAR_PRINT) + char(13) +
        '***exceeds maximum print value***';

    if ReplaceLineBreak then
      aStrLst.Text := StringReplace(aStrLst.Text, aStrLst.LineBreak, #13,
        [rfReplaceAll]);

    Size := Length(aStrLst.Text) * 2;
    Buffer := PAnsiChar(String(aStrLst.Text));

    { Send the data over as a Blob object to RAVE }
    Connection.WriteBlobData(Buffer^, Size);

  end;

begin
  ov := '';
  ListTitle := 'ListName';
  RPCReturnList := TStringList.Create;
  try
    with Connection do
    begin
      TmpStrLst := TStringList.Create;
      try
        ListName := ListN[0];
        // [ListName]
        WriteStrData(GetTeamName(ListName), '');

        // [User]
        WriteStrData(piece(frmListSelect.User, '^', 2), '');

        // [User contact]
        WriteStrData(GetUserContactInfo(frmListSelect.DUZ), '');

        // Get Contact Info
        GetContactInfo(ListName, RPCReturnList, TmpStrLst);

        // [Contact1]
        WriteBlobToReport(RPCReturnList, true);

        // [Contact2]
        WriteBlobToReport(TmpStrLst, true);

        // [PatientName]
        TmpStr := '';
        if Length(PatArray) >= Connection.DataIndex then
          TmpStr := piece(PatArray[Connection.DataIndex], '^', 2);
        WriteStrData(TmpStr, '');

        // [SSN]
        WriteStrData(GetPatDemo(Connection.DataIndex, RPCReturnList), '');

        // [PatDemo]
        WriteBlobToReport(RPCReturnList, true);

        // [Allergies]
        GetAllergies(Connection.DataIndex, RPCReturnList);
        WriteBlobToReport(RPCReturnList, true);

        // [CodeStatus]
        RPCReturnList.Clear;
        GetCodeStatus(Connection.DataIndex, RPCReturnList);
        WriteBlobToReport(RPCReturnList, true);

        // Get Meds
        GetMedication(Connection.DataIndex, RPCReturnList, TmpStrLst);

        // [Medication]
        WriteBlobToReport(RPCReturnList, true);

        // [Medication2]
        if XM then
          WriteBlobToReport(TmpStrLst, true);

        // [CoveringPhy]
        TmpStr := '';
        TmpStr := GetCoveringPhy(Connection.DataIndex);
        WriteStrData(TmpStr, '');

        // [lblTemp1]
        WriteStrData(frmListSelect.UserPar.TEMP_FLD_1_TITLE, '');

        // [lblTemp2]
        WriteStrData(frmListSelect.UserPar.TEMP_FLD_2_TITLE, '');
        // Temp fld label2

        // [lblTemp3]
        WriteStrData(frmListSelect.UserPar.TEMP_FLD_3_TITLE, '');
        // Temp fld label3

        // [lblTemp4]
        WriteStrData(frmListSelect.UserPar.TEMP_FLD_4_TITLE, '');
        // Temp fld label4

        // [Temp1]
        RPCReturnList.Clear;
        TmpStr := frmListSelect.UserPar.TEMP_FLD_1_TITLE;
        if TmpStr <> '' then
        begin
          GetTempfld(Connection.DataIndex, TmpStr, RPCReturnList);
          RPCReturnList.Text :=
            PrintText(TextExtend(RPCReturnList.Text, RPCReturnList.LineBreak));
          WriteBlobToReport(RPCReturnList);
        end;

        // [Temp2]
        RPCReturnList.Clear;
        TmpStr := frmListSelect.UserPar.TEMP_FLD_2_TITLE;
        if TmpStr <> '' then
        begin
          GetTempfld(Connection.DataIndex, TmpStr, RPCReturnList);
          RPCReturnList.Text :=
            PrintText(TextExtend(RPCReturnList.Text, RPCReturnList.LineBreak));
          WriteBlobToReport(RPCReturnList);
        end;

        // [Temp3]
        RPCReturnList.Clear;
        TmpStr := frmListSelect.UserPar.TEMP_FLD_3_TITLE;
        if TmpStr <> '' then
        begin
          GetTempfld(Connection.DataIndex, TmpStr, RPCReturnList);
          RPCReturnList.Text :=
            PrintText(TextExtend(RPCReturnList.Text, RPCReturnList.LineBreak));
          WriteBlobToReport(RPCReturnList);
        end;

        // [Temp4]
        RPCReturnList.Clear;
        TmpStr := frmListSelect.UserPar.TEMP_FLD_4_TITLE;
        if TmpStr <> '' then
        begin
          GetTempfld(Connection.DataIndex, TmpStr, RPCReturnList);
          RPCReturnList.Text :=
            PrintText(TextExtend(RPCReturnList.Text, RPCReturnList.LineBreak));
          WriteBlobToReport(RPCReturnList);
        end;
      finally
        TmpStrLst.Free;
      end;
    end;

  finally
    RPCReturnList.Free;
  end;

end;

Function TfrmReportM.PrintText(TextToPrint: string): string;
begin
  if Length(TextToPrint) > MAX_CHAR_PRINT then
  begin
    Result := copy(TextToPrint, 1, MAX_CHAR_PRINT) + char(13) +
      '***exceeds maximum print value***';
  end
  else
    Result := TextToPrint;
end;

procedure TfrmReportM.RvCConnectionOpen(Connection: TRvCustomConnection);
begin
  Connection.DataRows := High(PatArray) + 1;
end;

// =============================================================================
// Modified By:   ZZZZZZBELLC
// DateTime:      2017.8.14
// Description:
// (1) Clean up variables
// =============================================================================
procedure TfrmReportM.RvProjectCreate(Sender: TObject);
var
  i: integer;
  PL: String; // Page Orientation
  mList: TStringList;
  h: integer;
  s: string;

begin
  h := 0;
  mList := TStringList.Create;
  Try
    if frmListSelect.UserPar.PRINT_ORIENTATION = 'L' then
      PL := 'L'
    else
      PL := 'P';

    for i := 1 to 4 do // Temp fld
      case i of
        1:
          if frmListSelect.UserPar.TEMP_FLD_1_TITLE <> '' then
            inc(TitlesNum);
        2:
          if frmListSelect.UserPar.TEMP_FLD_2_TITLE <> '' then
            inc(TitlesNum);
        3:
          if frmListSelect.UserPar.TEMP_FLD_3_TITLE <> '' then
            inc(TitlesNum);
        4:
          if frmListSelect.UserPar.TEMP_FLD_4_TITLE <> '' then
            inc(TitlesNum);
      end;
    SizeProcess(PL);

    for i := 0 to frmListSelect.ORLbxPatients.count - 1 do
    begin
      mList.Clear;
      GetData(mList, 'CRHD PAT ACTMEDS',
        piece(frmListSelect.ORLbxPatients.Items[i], '^', 1) + '^' + 'I^' +
        IntToStr(frmListSelect.UserPar.MED_EXCLUDE_IV) + '^0^0^' +
        IntToStr(frmListSelect.UserPar.MED_DETAIL_FLG) + '^20');
      if mList.count > 0 then
        mList.Delete(0);
      if mList.count > 0 then
        if pos('UNIT DOSE', mList[0]) > 0 then
          mList.Delete(0);

      if mList.count > h then
        h := mList.count;
    end;

    if h > 5 then
      XM := true
    else
      XM := false;

    RvProject.Open;

    if XM then
      s := 'Report_' + PL + IntToStr(TitlesNum) + '_XM'
    else
      s := 'Report_' + PL + IntToStr(TitlesNum);

    RvProject.SelectReport(s, true);

    RvProject.SetParam('TF1', frmListSelect.UserPar.TEMP_FLD_1_TITLE);
    RvProject.SetParam('TF2', frmListSelect.UserPar.TEMP_FLD_2_TITLE);
    RvProject.SetParam('TF3', frmListSelect.UserPar.TEMP_FLD_3_TITLE);
    RvProject.SetParam('TF4', frmListSelect.UserPar.TEMP_FLD_4_TITLE);
  Finally
    mList.Free;
  End;
end;

procedure TfrmReportM.SizeProcess(PL: String);
begin
end;

procedure TfrmReportM.SortList(Slist, rlist: TStrings; flg: String);
begin
  if rlist = nil then
    rlist := TStringList.Create;
  tCallV(rlist, 'CRHD SORT PRINT LIST',
    [Slist, flg, frmListSelect.UserPar.PATIENT_DEMOGRAPHICS + '^256^' +
    IntToStr(frmListSelect.UserPar.PATIENT_DEMO_PRINTLBL)]);
end;

end.
