unit frmProviderTreeV;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ORCtrls, Menus, VA508AccessibilityManager, StdCtrls, ExtCtrls;
type
  TfrmTProvider = class(TForm)
    cboProvider: TORComboBox;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    Panel1: TPanel;
    btnCancel: TButton;
    btnOk: TButton;
    procedure cboProviderDblClick(Sender: TObject);
    procedure cboProviderNeedData(Sender: TObject; const StartFrom: String;
      Direction, InsertAt: Integer);
    procedure FormShow(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    procedure GetSelectedProvider;
  public
    { Public declarations }
    Team : String;
    sPrv : String;
  end;

var
  frmTProvider: TfrmTProvider;


function GetHOProviderTreeView(TM : String): String;

implementation

{$R *.DFM}

uses
  Util, Orfn, frmPrintData, VAUtils;

function GetHOProviderTreeView(TM : String): String;
var
frmPrvTree : TfrmTProvider;
begin
  frmPrvTree := TfrmTProvider.Create(Application);
  try
     with frmPrvTree do
     begin
       Team := TM;
       if frmPrvTree.cboProvider.Items.count = 0 then
        frmPrvTree.cboProvider.Items.AddStrings( SubSetHOTeamMembers(Team, '', 1, 1));

       if frmPrvTree.cboProvider.Items.count > 0 then
       begin
        showmodal;
        Result := sPrv + '~' + IntToStr(frmPrvTree.cboProvider.Items.count);
        end;
     end
  finally
     frmPrvTree.Free;
  end;
end;

procedure TfrmTProvider.btnCancelClick(Sender: TObject);
begin
  sPrv := '';
  Close;
end;

procedure TfrmTProvider.GetSelectedProvider;
begin
  if cboProvider.ItemIndex > -1 then begin
    sPrv := cboProvider.Items[cboProvider.ItemIndex];
    close;
  end else
    ShowMsg('Please select a provider from the list','Provider Not Selected');
end;

procedure TfrmTProvider.btnOkClick(Sender: TObject);
begin
  GetSelectedProvider;
end;

procedure TfrmTProvider.cboProviderDblClick(Sender: TObject);
begin
  GetSelectedProvider;
end;

procedure TfrmTProvider.cboProviderNeedData(Sender: TObject;
  const StartFrom: String; Direction, InsertAt: Integer);
begin
 cboProvider.ForDataUse(SubSetHOTeamMembers(Team, StartFrom, Direction, 1));
end;

procedure TfrmTProvider.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if sPrv = '' then
    cboProvider.Clear;
end;

procedure TfrmTProvider.FormShow(Sender: TObject);
begin
with cboProvider do
 begin
  ListItemsOnly := true;
  LongList := true;
  InitLongList('');
 end;
end;

end.
